1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
33 # Similarly, override this to store the test-results subdir
35 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
37 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
39 ################################################################
40 # It appears that people try to run tests without building...
41 "$GIT_BUILD_DIR/git" >/dev
/null
44 echo >&2 'error: you do not seem to have built git yet.'
48 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49 export PERL_PATH SHELL_PATH
51 # if --tee was passed, write the output not only to the terminal, but
52 # additionally to the file test-results/$BASENAME.out, too.
53 case "$GIT_TEST_TEE_STARTED, $* " in
55 # do not redirect again
57 *' --tee '*|
*' --va'*)
58 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
60 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
61 echo $?
> $BASE.
exit) |
tee $BASE.out
62 test "$(cat $BASE.exit)" = 0
67 # For repeatability, reset the environment to known value.
68 # TERM is sanitized below, after saving color control sequences.
73 export LANG LC_ALL PAGER TZ
75 # A call to "unset" with no arguments causes at least Solaris 10
76 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
77 # deriving from the command substitution clustered with the other
79 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
81 my $ok = join("|", qw(
93 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
94 print join("\n", @vars);
98 GIT_AUTHOR_EMAIL
=author@example.com
99 GIT_AUTHOR_NAME
='A U Thor'
100 GIT_COMMITTER_EMAIL
=committer@example.com
101 GIT_COMMITTER_NAME
='C O Mitter'
102 GIT_MERGE_VERBOSITY
=5
103 GIT_MERGE_AUTOEDIT
=no
104 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
105 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
106 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
109 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
111 export GIT_TRACE_BARE
113 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
115 GIT_INDEX_VERSION
="$TEST_GIT_INDEX_VERSION"
116 export GIT_INDEX_VERSION
119 # Add libc MALLOC and MALLOC_PERTURB test
120 # only if we are not executing the test with valgrind
121 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
122 test -n "$TEST_NO_MALLOC_CHECK"
124 setup_malloc_check
() {
127 teardown_malloc_check
() {
131 setup_malloc_check
() {
132 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
133 export MALLOC_CHECK_ MALLOC_PERTURB_
135 teardown_malloc_check
() {
136 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 : ${ASAN_OPTIONS=detect_leaks=0}
143 # Protect ourselves from common misconfiguration to export
144 # CDPATH into the environment
150 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
158 # A regexp to match 5 and 40 hexdigits
159 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
160 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
163 _z40
=0000000000000000000000000000000000000000
169 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
170 # when case-folding filenames
171 u200c
=$
(printf '\342\200\214')
173 export _x05 _x40 _z40 LF u200c
175 # Each test should start with something like this, after copyright notices:
177 # test_description='Description of this test...
178 # This test checks if command xyzzy does the right thing...
181 test "x$TERM" != "xdumb" && (
183 tput bold
>/dev
/null
2>&1 &&
184 tput setaf
1 >/dev
/null
2>&1 &&
185 tput sgr0
>/dev
/null
2>&1
189 while test "$#" -ne 0
192 -d|
--d|
--de|
--deb|
--debu|
--debug)
194 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
195 immediate
=t
; shift ;;
196 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
197 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
199 shift; test "$#" -ne 0 ||
{
200 echo 'error: -r requires an argument' >&2;
203 run_list
=$1; shift ;;
205 run_list
=$
(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
206 -h|
--h|
--he|
--hel|
--help)
208 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
211 verbose_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
213 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
218 with_dashes
=t
; shift ;;
221 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
225 valgrind
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
228 valgrind_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
231 shift ;; # was handled already
233 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
236 GIT_TEST_CHAIN_LINT
=1
239 GIT_TEST_CHAIN_LINT
=0
246 echo "error: unknown test option '$1'" >&2; exit 1 ;;
250 if test -n "$valgrind_only"
252 test -z "$valgrind" && valgrind
=memcheck
253 test -z "$verbose" && verbose_only
="$valgrind_only"
254 elif test -n "$valgrind"
261 # Save the color control sequences now rather than run tput
262 # each time say_color() is called. This is done for two
264 # * TERM will be changed to dumb
265 # * HOME will be changed to a temporary directory and tput
266 # might need to read ~/.terminfo from the original HOME
267 # directory to get the control sequences
268 # Note: This approach assumes the control sequences don't end
269 # in a newline for any terminal of interest (command
270 # substitutions strip trailing newlines). Given that most
271 # (all?) terminals in common use are related to ECMA-48, this
272 # shouldn't be a problem.
273 say_color_error
=$
(tput bold
; tput setaf
1) # bold red
274 say_color_skip
=$
(tput setaf
4) # blue
275 say_color_warn
=$
(tput setaf
3) # brown/yellow
276 say_color_pass
=$
(tput setaf
2) # green
277 say_color_info
=$
(tput setaf
6) # cyan
278 say_color_reset
=$
(tput sgr0
)
279 say_color_
="" # no formatting for normal text
281 test -z "$1" && test -n "$quiet" && return
282 eval "say_color_color=\$say_color_$1"
284 printf "%s\\n" "$say_color_color$*$say_color_reset"
288 test -z "$1" && test -n "$quiet" && return
298 say_color error
"error: $*"
307 test "${test_description}" != "" ||
308 error
"Test script did not set test_description."
310 if test "$help" = "t"
312 printf '%s\n' "$test_description"
318 if test "$verbose" = "t"
322 exec 4>/dev
/null
3>/dev
/null
331 test_external_has_tap
=0
335 if test -n "$GIT_EXIT_OK"
339 echo >&5 "FATAL: Unexpected exit with code $code"
348 # The user-facing functions are loaded from a separate file so that
349 # test_perf subshells can have them too
350 .
"$TEST_DIRECTORY/test-lib-functions.sh"
352 # You are not expected to call test_ok_ and test_failure_ directly, use
353 # the test_expect_* functions instead.
356 test_success
=$
(($test_success + 1))
357 say_color
"" "ok $test_count - $@"
361 test_failure
=$
(($test_failure + 1))
362 say_color error
"not ok $test_count - $1"
364 printf '%s\n' "$*" |
sed -e 's/^/# /'
365 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
368 test_known_broken_ok_
() {
369 test_fixed
=$
(($test_fixed+1))
370 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
373 test_known_broken_failure_
() {
374 test_broken
=$
(($test_broken+1))
375 say_color warn
"not ok $test_count - $@ # TODO known breakage"
379 test "$debug" = "" ||
eval "$1"
382 match_pattern_list
() {
385 test -z "$*" && return 1
396 match_test_selector_list
() {
401 test -z "$1" && return 0
403 # Both commas and whitespace are accepted as separators.
409 # If the first selector is negative we include by default.
417 orig_selector
=$selector
423 selector
=${selector##?}
427 test -z "$selector" && continue
431 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
433 echo "error: $title: invalid non-numeric in range" \
434 "start: '$orig_selector'" >&2
437 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
439 echo "error: $title: invalid non-numeric in range" \
440 "end: '$orig_selector'" >&2
445 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
447 echo "error: $title: invalid non-numeric in test" \
448 "selector: '$orig_selector'" >&2
453 # Short cut for "obvious" cases
454 test -z "$include" && test -z "$positive" && continue
455 test -n "$include" && test -n "$positive" && continue
459 if test $arg -le ${selector#-}
465 if test $arg -ge ${selector%-}
471 if test ${selector%%-*} -le $arg \
472 && test $arg -le ${selector#*-}
478 if test $arg -eq $selector
489 maybe_teardown_verbose
() {
490 test -z "$verbose_only" && return
491 exec 4>/dev
/null
3>/dev
/null
496 maybe_setup_verbose
() {
497 test -z "$verbose_only" && return
498 if match_pattern_list
$test_count $verbose_only
501 # Emit a delimiting blank line when going from
502 # non-verbose to verbose. Within verbose mode the
503 # delimiter is printed by test_expect_*. The choice
504 # of the initial $last_verbose is such that before
505 # test 1, we do not print it.
506 test -z "$last_verbose" && echo >&3 ""
509 exec 4>/dev
/null
3>/dev
/null
512 last_verbose
=$verbose
515 maybe_teardown_valgrind
() {
516 test -z "$GIT_VALGRIND" && return
517 GIT_VALGRIND_ENABLED
=
520 maybe_setup_valgrind
() {
521 test -z "$GIT_VALGRIND" && return
522 if test -z "$valgrind_only"
524 GIT_VALGRIND_ENABLED
=t
527 GIT_VALGRIND_ENABLED
=
528 if match_pattern_list
$test_count $valgrind_only
530 GIT_VALGRIND_ENABLED
=t
535 test "$trace" = t
&& test "$verbose" = t
538 # This is a separate function because some tests use
539 # "return" to end a test_expect_success block early
540 # (and we want to make sure we run any cleanup like
542 test_eval_inner_
() {
543 # Do not add anything extra (including LF) after '$*'
550 # We run this block with stderr redirected to avoid extra cruft
551 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
552 # the shell from printing the "set +x" to turn it off (nor the saving
553 # of $? before that). But we can make sure that the output goes to
556 # The test itself is run with stderr put back to &4 (so either to
557 # /dev/null, or to the original stderr if --verbose was used).
559 test_eval_inner_
"$@" </dev
/null
>&3 2>&4
564 if test "$test_eval_ret_" != 0
566 say_color error
>&4 "error: last command exited with \$?=$test_eval_ret_"
570 return $test_eval_ret_
577 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
578 # turn off tracing for this test-eval, as it simply creates
579 # confusing noise in the "-x" output
582 # 117 is magic because it is unlikely to match the exit
583 # code of other programs
584 test_eval_
"(exit 117) && $1"
585 if test "$?" != 117; then
586 error
"bug in the test script: broken &&-chain: $1"
594 teardown_malloc_check
596 if test -z "$immediate" ||
test $eval_ret = 0 ||
597 test -n "$expecting_failure" && test "$test_cleanup" != ":"
600 test_eval_
"$test_cleanup"
601 teardown_malloc_check
603 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
611 test_count
=$
(($test_count+1))
618 maybe_teardown_valgrind
619 maybe_teardown_verbose
625 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
628 skipped_reason
="GIT_SKIP_TESTS"
630 if test -z "$to_skip" && test -n "$test_prereq" &&
631 ! test_have_prereq
"$test_prereq"
636 if test "$missing_prereq" != "$test_prereq"
638 of_prereq
=" of $test_prereq"
640 skipped_reason
="missing $missing_prereq${of_prereq}"
642 if test -z "$to_skip" && test -n "$run_list" &&
643 ! match_test_selector_list
'--run' $test_count "$run_list"
646 skipped_reason
="--run"
651 say_color skip
>&3 "skipping test: $@"
652 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
661 # stub; perf-lib overrides it
662 test_at_end_hook_
() {
669 if test -z "$HARNESS_ACTIVE"
671 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
672 mkdir
-p "$test_results_dir"
674 test_results_path
="$test_results_dir/${base%.sh}-$$.counts"
676 cat >>"$test_results_path" <<-EOF
678 success $test_success
686 if test "$test_fixed" != 0
688 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
690 if test "$test_broken" != 0
692 say_color warn
"# still have $test_broken known breakage(s)"
694 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
696 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
697 msg
="remaining $test_remaining test(s)"
699 test_remaining
=$test_count
700 msg
="$test_count test(s)"
702 case "$test_failure" in
704 # Maybe print SKIP message
705 if test -n "$skip_all" && test $test_count -gt 0
707 error
"Can't use skip_all after running some tests"
709 test -z "$skip_all" || skip_all
=" # SKIP $skip_all"
711 if test $test_external_has_tap -eq 0
713 if test $test_remaining -gt 0
715 say_color pass
"# passed all $msg"
717 say
"1..$test_count$skip_all"
720 test -d "$remove_trash" &&
721 cd "$(dirname "$remove_trash")" &&
722 rm -rf "$(basename "$remove_trash")"
729 if test $test_external_has_tap -eq 0
731 say_color error
"# failed $test_failure among $msg"
740 if test -n "$valgrind"
744 test "$1" = "$(readlink "$2")" ||
{
752 while test -d "$2".lock
754 say
"Waiting for lock on $2."
761 make_valgrind_symlink
() {
762 # handle only executables, unless they are shell libraries that
763 # need to be in the exec-path.
765 test "# " = "$(head -c 2 <"$1")" ||
768 base
=$
(basename "$1")
769 symlink_target
=$GIT_BUILD_DIR/$base
770 # do not override scripts
771 if test -x "$symlink_target" &&
772 test ! -d "$symlink_target" &&
773 test "#!" != "$(head -c 2 < "$symlink_target")"
775 symlink_target
=..
/valgrind.sh
779 symlink_target
=..
/unprocessed-script
781 # create the link, or replace it if it is out of date
782 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
785 # override all git executables in TEST_DIRECTORY/..
786 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
787 mkdir
-p "$GIT_VALGRIND"/bin
788 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
790 make_valgrind_symlink
$file
792 # special-case the mergetools loadables
793 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
798 ls "$path"/git-
* 2> /dev
/null |
801 make_valgrind_symlink
"$file"
805 PATH
=$GIT_VALGRIND/bin
:$PATH
806 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
808 GIT_VALGRIND_MODE
="$valgrind"
809 export GIT_VALGRIND_MODE
810 GIT_VALGRIND_ENABLED
=t
811 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
812 export GIT_VALGRIND_ENABLED
813 elif test -n "$GIT_TEST_INSTALLED"
815 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
816 error
"Cannot run git from $GIT_TEST_INSTALLED."
817 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
818 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
819 else # normal case, use ../bin-wrappers only unless $with_dashes:
820 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
821 if ! test -x "$git_bin_dir/git"
823 if test -z "$with_dashes"
825 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
829 PATH
="$git_bin_dir:$PATH"
830 GIT_EXEC_PATH
=$GIT_BUILD_DIR
831 if test -n "$with_dashes"
833 PATH
="$GIT_BUILD_DIR:$PATH"
836 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
837 GIT_CONFIG_NOSYSTEM
=1
839 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
841 if test -z "$GIT_TEST_CMP"
843 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
845 GIT_TEST_CMP
="$DIFF -c"
847 GIT_TEST_CMP
="$DIFF -u"
851 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
853 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
854 error
"You haven't built things yet, have you?"
857 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
859 echo >&2 'You need to build test-chmtime:'
860 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
865 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
866 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
867 case "$TRASH_DIRECTORY" in
868 /*) ;; # absolute path is good
869 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
871 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
872 rm -fr "$TRASH_DIRECTORY" ||
{
874 echo >&5 "FATAL: Cannot prepare test area"
878 HOME
="$TRASH_DIRECTORY"
879 GNUPGHOME
="$HOME/gnupg-home-not-used"
880 export HOME GNUPGHOME
882 if test -z "$TEST_NO_CREATE_REPO"
884 test_create_repo
"$TRASH_DIRECTORY"
886 mkdir
-p "$TRASH_DIRECTORY"
888 # Use -P to resolve symlinks in our working directory so that the cwd
889 # in subprocesses like git equals our $PWD (for pathname comparisons).
890 cd -P "$TRASH_DIRECTORY" ||
exit 1
893 this_test
=${this_test%%-*}
894 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
896 say_color info
>&3 "skipping test $this_test altogether"
897 skip_all
="skip all tests in $this_test"
901 # Provide an implementation of the 'yes' utility
916 # Fix some commands on Windows
919 # Windows has its own (incompatible) sort and find
929 # git sees Windows-style pwd
933 # no POSIX permissions
934 # backslashes in pathspec are converted to '/'
935 # exec does not inherit the PID
936 test_set_prereq MINGW
937 test_set_prereq NATIVE_CRLF
938 test_set_prereq SED_STRIPS_CR
939 test_set_prereq GREP_STRIPS_CR
940 GIT_TEST_CMP
=mingw_test_cmp
943 test_set_prereq POSIXPERM
944 test_set_prereq EXECKEEPSPID
945 test_set_prereq CYGWIN
946 test_set_prereq SED_STRIPS_CR
947 test_set_prereq GREP_STRIPS_CR
950 test_set_prereq POSIXPERM
951 test_set_prereq BSLASHPSPEC
952 test_set_prereq EXECKEEPSPID
956 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
957 test -z "$NO_PERL" && test_set_prereq PERL
958 test -z "$NO_PYTHON" && test_set_prereq PYTHON
959 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
960 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
962 # Can we rely on git's output in the C locale?
963 if test -n "$GETTEXT_POISON"
965 GIT_GETTEXT_POISON
=YesPlease
966 export GIT_GETTEXT_POISON
967 test_set_prereq GETTEXT_POISON
969 test_set_prereq C_LOCALE_OUTPUT
972 # Use this instead of test_cmp to compare files that contain expected and
973 # actual output from git commands that can be translated. When running
974 # under GETTEXT_POISON this pretends that the command produced expected
977 test -n "$GETTEXT_POISON" || test_cmp
"$@"
980 # Use this instead of "grep expected-string actual" to see if the
981 # output from a git command that can be translated either contains an
982 # expected string, or does not contain an unwanted one. When running
983 # under GETTEXT_POISON this pretends that the command produced expected
986 if test -n "$GETTEXT_POISON"
989 elif test "x!" = "x$1"
998 test_lazy_prereq PIPE
'
999 # test whether the filesystem supports FIFOs
1005 rm -f testfifo && mkfifo testfifo
1010 test_lazy_prereq SYMLINKS
'
1011 # test whether the filesystem supports symbolic links
1012 ln -s x y && test -h y
1015 test_lazy_prereq FILEMODE
'
1016 test "$(git config --bool core.filemode)" = true
1019 test_lazy_prereq CASE_INSENSITIVE_FS
'
1020 echo good >CamelCase &&
1021 echo bad >camelcase &&
1022 test "$(cat CamelCase)" != good
1025 test_lazy_prereq UTF8_NFD_TO_NFC
'
1026 # check whether FS converts nfd unicode to nfc
1027 auml=$(printf "\303\244")
1028 aumlcdiar=$(printf "\141\314\210")
1038 test_lazy_prereq AUTOIDENT
'
1039 sane_unset GIT_AUTHOR_NAME &&
1040 sane_unset GIT_AUTHOR_EMAIL &&
1041 git var GIT_AUTHOR_IDENT
1044 test_lazy_prereq EXPENSIVE
'
1045 test -n "$GIT_TEST_LONG"
1048 test_lazy_prereq USR_BIN_TIME
'
1049 test -x /usr/bin/time
1052 test_lazy_prereq NOT_ROOT
'
1057 # On a filesystem that lacks SANITY, a file can be deleted even if
1058 # the containing directory doesn't have write permissions, or a file
1059 # can be accessed even if the containing directory doesn't have read
1060 # or execute permissions, causing our tests that validate that Git
1061 # works sensibly in such situations.
1062 test_lazy_prereq SANITY
'
1063 mkdir SANETESTD.1 SANETESTD.2 &&
1065 chmod +w SANETESTD.1 SANETESTD.2 &&
1066 >SANETESTD.1/x 2>SANETESTD.2/x &&
1067 chmod -w SANETESTD.1 &&
1068 chmod -rx SANETESTD.2 ||
1069 error "bug in test sript: cannot prepare SANETESTD"
1071 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1074 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1075 rm -rf SANETESTD.1 SANETESTD.2 ||
1076 error "bug in test sript: cannot clean SANETESTD"
1080 GIT_UNZIP
=${GIT_UNZIP:-unzip}
1081 test_lazy_prereq UNZIP
'
1086 run_with_limited_cmdline
() {
1087 (ulimit -s 128 && "$@")
1090 test_lazy_prereq CMDLINE_LIMIT
'run_with_limited_cmdline true'